import {select,csv,scaleLinear,max,scaleBand,yAxis,axisLeft,axisBottom,format,colorScale} from 'd3';

const svg=select('#svg1');

const width1=+svg.attr('width');

const height1=+svg.attr('height');

const render1=data=>{
  const xval=d=>d.Height;
  const yval=d=>d.Name;
  const margin={top:60,right:200,bottom:100,left:200};
  const innerwidth=width1-margin.left-margin.right;
  const innerheight=height1-margin.top-margin.bottom;
  
 	const xScale=scaleLinear().domain([0,max(data,xval)]).range([0,innerwidth]);
  
  const yScale=scaleBand().domain(data.map(yval)).range([0,innerheight])
  .padding(0.3);
  
  const g=svg.append('g').attr('transform',`translate(${margin.left},${margin.top})`);
  
  g.append('g').call(axisLeft(yScale));
  
	const xaxis=axisBottom(xScale).tickSize(-innerheight);	
  const   xaxisg=g.append('g').call(xaxis).attr('transform',`translate(0,${innerheight})`);
  
  
  xaxisg.append('text').attr('class','axis-label').attr('y',65).attr('x',innerwidth/2-40).attr('fill','black').text('Heights');
  
  g.selectAll('rect').data(data).enter().append('rect').attr('y',d=>yScale(yval(d))).
  attr('width',d=>xScale(xval(d))).attr('height',yScale.bandwidth()).attr("fill", function(data) {
    if (data['Eye Color']=="Blue") {
      return "blue";
    } else if (data['Eye Color']=="Brown") {
      return "brown";
    }
    return "black";
  });
  
  g.append('text').attr('y',-10).attr('x',-150)
  .text('Student Heights sorted by Height');
  
};



const sv2=select('#svg2');

const width2=+sv2.attr('width');

const height2=+sv2.attr('height');

const render2=data=>{
  const xval2=d=>d.Height;
  const yval2=d=>d.Name;
  const margin2={top:60,right:200,bottom:100,left:200};
  const innerwidth2=width2-margin2.left-margin2.right;
  const innerheight2=height2-margin2.top-margin2.bottom;
  
 	const xScale2=scaleLinear().domain([0,max(data,xval2)]).range([0,innerwidth2]);
  
  const yScale2=scaleBand().domain(data.map(yval2)).range([0,innerheight2])
  .padding(0.3);
  
  const g2=sv2.append('g').attr('transform',`translate(${margin2.left},${margin2.top})`);
  
  g2.append('g').call(axisLeft(yScale2));
  
	const xaxis2=axisBottom(xScale2).tickSize(-innerheight2);	
  const   xaxisg2=g2.append('g').call(xaxis2).attr('transform',`translate(0,${innerheight2})`);
  
  xaxisg2.append('text').attr('class','axis-label').attr('y',65).attr('x',innerwidth2/2-40).attr('fill','black').text('Heights');
  
  g2.selectAll('rect').data(data).enter().append('rect').attr('y',d=>yScale2(yval2(d))).
  attr('width',d=>xScale2(xval2(d))).attr('height',yScale2.bandwidth()).attr("fill", function(data) {
    if (data['Eye Color']=="Blue") {
      return "blue";
    } else if (data['Eye Color']=="Brown") {
      return "brown";
    }
    return "black";
  });
  
  g2.append('text').attr('y',-10).attr('x',-150)
  .text('Student Heights sorted by Name');
  
};



csv('population.csv').then(function(data){
  
  data.forEach(d=>{
    if(d.Height=='x'){
      d.Height=0;
    }
    d.Height=+d.Height
  });
  
  data.sort(function(a,b) {
					return d3.descending(+a.Height,+b.Height)});

  
  render1(data);
});

csv('population.csv').then(function(data){
  
  data.forEach(d=>{
    if(d.Height=='x'){
      d.Height=0;
    }
    d.Height=+d.Height
  });
  
  
  
  data.sort(function(a,b) {
					return d3.ascending(a.Name,b.Name)});
  
  render2(data);
});